## kwave 0.8.10

=== CMakeLists.txt ===
#############################################################################
##    Kwave                - CMakeLists.txt
##                           -------------------
##    begin                : Tue May 01 2007
##    copyright            : (C) 2007 by Thomas Eschenbacher
##    email                : Thomas.Eschenbacher@gmx.de
#############################################################################
#
#############################################################################
##                                                                          #
##    This program is free software; you can redistribute it and/or modify  #
##    it under the terms of the GNU General Public License as published by  #
##    the Free Software Foundation; either version 2 of the License, or     #
##    (at your option) any later version.                                   #
##                                                                          #
#############################################################################

#############################################################################
### project name                                                          ###

PROJECT(kwave)

SET(KWAVE_LINGUAS
    cs:čeština
    de:Deutsch
    en:English
    fr:Francais
    # <- add new languages here...
)

#############################################################################
### build options:                                                        ###

# OPTION(DEBUG           "build debug code [default=off]" OFF)
# OPTION(WITH_ALSA       "enable playback/recording via ALSA [default=on]" ON)
# OPTION(WITH_DOC        "build online documentation [default=on]" ON)
# OPTION(WITH_FLAC       "enable support for FLAC files [default=on]" ON)
# OPTION(WITH_MP3        "enable support for mp3 files [default=off]" OFF)
# OPTION(WITH_OGG_OPUS   "enable support for ogg/opus files [default=on]" ON)
# OPTION(WITH_OGG_VORBIS "enable support for ogg/vorbis files [default=on]" ON)
# OPTION(WITH_OSS        "enable playback/recording via OSS [default=on]" ON)
# OPTION(WITH_OPTIMIZED_MEMCPY "enable optimized memcpy [default=on]" ON)
# OPTION(WITH_PHONON     "enable playback via Phonon [default=off]" OFF)
# OPTION(WITH_PULSEAUDIO "enable playback/recording via PulseAudio [default=on]" ON)

#############################################################################
### toplevel build targets:                                               ###

# all            - default target, build all files
# clean          - clean up the current build directory
# doc            - generate docbook files for online help
# distfiles      - generate subdirectory with all files for distribution
# html_doc       - generate HTML help (for the web)
# install        - install the package, with support for DESTDIR
# rpm            - create a RPM package + a src.rpm file
# src_rpm        - create the source RPM only
# tarball        - create a tar.bz2 archive with the sources + specfile
# uninstall      - uninstall the package, with support for DESTDIR
# version-labels - update all version numbers and build dates
# tarball        - create a tar.gz file with the sources

#############################################################################
### check for the proper cmake version                                    ###

CMAKE_MINIMUM_REQUIRED(VERSION 2.6.0 FATAL_ERROR)

#############################################################################
### path to additional cmake modules and includes                         ###

SET(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)

#############################################################################
### Kwave version number                                                  ###

INCLUDE(FindKwaveVersion)

#############################################################################
### show the compiler and it's version                                    ###

EXECUTE_PROCESS(
    COMMAND ${CMAKE_C_COMPILER} -dumpversion
    OUTPUT_VARIABLE COMPILER_VERSION
    OUTPUT_STRIP_TRAILING_WHITESPACE
)
GET_FILENAME_COMPONENT(COMPILER_SHORT "${CMAKE_C_COMPILER}" NAME_WE CACHE)
MESSAGE(STATUS "Building with ${COMPILER_SHORT} version ${COMPILER_VERSION}")

#############################################################################
### check for the CPU we build for                                        ###

EXECUTE_PROCESS(
    COMMAND ${CMAKE_C_COMPILER} -dumpmachine
    OUTPUT_VARIABLE MACHINE
    OUTPUT_STRIP_TRAILING_WHITESPACE
)
MESSAGE(STATUS "Building for target ${MACHINE}")

OPTION(WITH_OPTIMIZED_MEMCPY "enable optimized memcpy [default=on]" ON)
IF (WITH_OPTIMIZED_MEMCPY)

    STRING(REGEX MATCH "(i.86-*)|(athlon-*)|(pentium-*)" _mach_x86 ${MACHINE})
    IF (_mach_x86)
        MESSAGE(STATUS "Found target optimized memcpy() for X86 (from xine)")
        SET(ARCH_X86 1)
    ENDIF (_mach_x86)

    STRING(REGEX MATCH "(x86_64-*)|(X86_64-*)|(AMD64-*)|(amd64-*)" _mach_x86_64 ${MACHINE})
    IF (_mach_x86_64)
        MESSAGE(STATUS "Found target optimized memcpy() for X86_64 (from xine)")
        SET(ARCH_X86_64 1)
    ENDIF (_mach_x86_64)

    STRING(REGEX MATCH "(ppc-*)|(powerpc-*)" _mach_ppc ${MACHINE})
    IF (_mach_ppc)
        MESSAGE(STATUS "Found target optimized memcpy() for PPC (from xine)")
        SET(ARCH_PPC 1)
    ENDIF (_mach_ppc)

    IF (NOT ARCH_X86 AND NOT ARCH_X86_64 AND NOT ARCH_PPC)
        MESSAGE(STATUS "No platform specific memcpy available")
    ENDIF (NOT ARCH_X86 AND NOT ARCH_X86_64 AND NOT ARCH_PPC)

ELSE (WITH_OPTIMIZED_MEMCPY)
    MESSAGE(STATUS "Platform specific memcpy is disabled")
ENDIF (WITH_OPTIMIZED_MEMCPY)

#############################################################################
### cmake includes                                                        ###

INCLUDE(CheckIncludeFiles)
INCLUDE(CheckCCompilerFlag)
INCLUDE(CheckCXXCompilerFlag)
INCLUDE(CheckTypeSize)
INCLUDE(CheckFunctionExists)
INCLUDE(KwaveL10N)

#############################################################################

SET(CMAKE_VERBOSE_MAKEFILE OFF)

#############################################################################
### toplevel compiler flags                                               ###

ADD_DEFINITIONS(-DHAVE_CONFIG_H)
ADD_DEFINITIONS(-DQT_NO_CAST_TO_ASCII)
ADD_DEFINITIONS(-DQT_NO_CAST_FROM_ASCII)

CHECK_C_COMPILER_FLAG(" ${CMAKE_SHARED_LIBRARY_C_FLAGS}" C_HAVE_PIC)
CHECK_CXX_COMPILER_FLAG(" ${CMAKE_SHARED_LIBRARY_C_FLAGS}" CXX_HAVE_PIC)
IF (CXX_HAVE_PIC AND C_HAVE_PIC)
    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${CMAKE_SHARED_LIBRARY_C_FLAGS}")
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CMAKE_SHARED_LIBRARY_C_FLAGS}")
ELSE (CXX_HAVE_PIC AND C_HAVE_PIC)
    MESSAGE(FATAL_ERROR "shared library support is missing")
ENDIF (CXX_HAVE_PIC AND C_HAVE_PIC)

# disable annoying warnings from Qt about strict aliasing
CHECK_CXX_COMPILER_FLAG("-Wno-strict-aliasing" CXX_NO_STRICT_ALIASING)
IF (CXX_NO_STRICT_ALIASING)
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-strict-aliasing")
ENDIF (CXX_NO_STRICT_ALIASING)

#############################################################################

LINK_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR}/libgui)
LINK_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR}/libkwave)

#############################################################################
### Qt 4 support                                                          ###

SET(QT_USE_QT3SUPPORT OFF)
SET(QT_USE_QTUITOOLS ON)
SET(QT_USE_QTCORE ON)
SET(QT_DONTUSE_QTGUI OFF)
SET(QT_USE_QTMAIN ON)

FIND_PACKAGE(Qt4 4.5.0 REQUIRED)
MESSAGE(STATUS "Found Qt4 version ${QTVERSION}")
MESSAGE(STATUS "Found Qt4 libraries in ${QT_LIBRARY_DIR}")
MESSAGE(STATUS "Found Qt4 header files in ${QT_INCLUDE_DIR}")

#############################################################################
### KDE 4 support                                                         ###

SET(KDE4_ENABLE_FPIE ON)

FIND_PROGRAM(KDECONFIG_EXECUTABLE kde4-config)
FIND_PACKAGE(KDE4 REQUIRED)
IF(WIN32)
  FIND_PACKAGE(KDEWIN32 REQUIRED)
ENDIF(WIN32)
INCLUDE(KDE4Defaults)
ADD_DEFINITIONS(${KDE4_DEFINITIONS})

SET(QT_AND_KDECORE_LIBS
    ${QT_QTGUI_LIBRARY}
    ${QT_LIBRARIES}
    ${KDE4_THREADWEAVER_LIBRARY}
    ${KDE4_KDECORE_LIBS}
    ${KDE4_KDEUI_LIBRARY}
    ${KDE4_KIO_LIBRARY}
    pthread
)

INCLUDE_DIRECTORIES(
    ${KDE4_INCLUDE_DIR}
    ${QT_INCLUDE_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
)

#############################################################################
### RPATH settings                                                        ###

SET(CMAKE_SKIP_BUILD_RPATH TRUE)
SET(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)
SET(CMAKE_INSTALL_RPATH "${KDE4_LIB_INSTALL_DIR}")
SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
MESSAGE(STATUS "Using ${CMAKE_INSTALL_RPATH} as install RPATH")

#############################################################################
### checks for needed header files                                        ###

CHECK_INCLUDE_FILES(sys/times.h HAVE_SYS_TIMES_H)
CHECK_INCLUDE_FILES(signal.h HAVE_SIGNAL_H)
CHECK_INCLUDE_FILES(unistd.h HAVE_UNISTD_H)
CHECK_INCLUDE_FILES(sys/types.h HAVE_SYS_TYPES_H)
CHECK_INCLUDE_FILES(stdint.h HAVE_STDINT_H)
CHECK_INCLUDE_FILES(stddef.h HAVE_STDDEF_H)

SET(_inc errno.h float.h limits.h math.h sched.h signal.h stddef.h
         stdint.h stdio.h stdlib.h string.h sys/types.h unistd.h pthread.h)
CHECK_INCLUDE_FILES("${_inc}" REQUIRED_STD_HEADERS)
IF (NOT REQUIRED_STD_HEADERS)
    MESSAGE(FATAL_ERROR "
        unable to find one or more of the following header files:
        ${_inc}")
ENDIF (NOT REQUIRED_STD_HEADERS)

#############################################################################
### checks for some functions                                             ###

CHECK_FUNCTION_EXISTS(unlink HAVE_UNLINK)

INCLUDE(KwaveSysinfo)

#############################################################################
### libaudiofile and libsamplerate support                                ###

INCLUDE(KwaveLibaudiofileSupport)
INCLUDE(KwaveLibsamplerateSupport)

#############################################################################
### optionally: OSS, ALSA, PulseAudio and Phonon support                  ###
### for playback/recording                                                ###

INCLUDE(KwaveOSSSupport)
INCLUDE(KwaveALSASupport)
INCLUDE(KwavePhononSupport)
INCLUDE(KwavePulseAudioSupport)

#############################################################################
### cmake includes                                                        ###

FIND_PACKAGE(RequiredProgram REQUIRED)
FIND_PACKAGE(Gettext REQUIRED)

#############################################################################
### flags for debugging                                                   ###

OPTION(DEBUG "build debug code [default=off]" OFF)
IF (DEBUG)
    SET(CMAKE_DEBUG_FLAGS "-O0 -g -Wall -W -Wextra -pedantic -fno-inline -fstack-protector-all")
    SET(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   ${CMAKE_DEBUG_FLAGS}")
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CMAKE_DEBUG_FLAGS} -Wstrict-null-sentinel -Wold-style-cast")
    ADD_DEFINITIONS(-DDEBUG -D_DEBUG)
ELSE(DEBUG)
    ADD_DEFINITIONS(-DNO_DEBUG -DQT_NO_DEBUG)
ENDIF (DEBUG)

#############################################################################
### subdirs                                                               ###

ADD_SUBDIRECTORY( libgui )
ADD_SUBDIRECTORY( libkwave )
ADD_SUBDIRECTORY( kwave )
ADD_SUBDIRECTORY( plugins )
ADD_SUBDIRECTORY( po )

SET(KWAVE_BUILD_LINGUAS ${KWAVE_BUILD_LINGUAS})
OPTION(WITH_DOC "build online documentation [default=on]" ON)
IF (WITH_DOC)
    ADD_SUBDIRECTORY( doc )
ENDIF (WITH_DOC)

#############################################################################
### target package-messages                                               ###

INCLUDE(KwavePackageMessages)

#############################################################################

=== libgui/CMakeLists.txt ===
#############################################################################
##    Kwave                - libgui/CMakeLists.txt
##                           -------------------
##    begin                : Tue May 01 2007
##    copyright            : (C) 2007 by Thomas Eschenbacher
##    email                : Thomas.Eschenbacher@gmx.de
#############################################################################
#
#############################################################################
##                                                                          #
##    This program is free software; you can redistribute it and/or modify  #
##    it under the terms of the GNU General Public License as published by  #
##    the Free Software Foundation; either version 2 of the License, or     #
##    (at your option) any later version.                                   #
##                                                                          #
#############################################################################

#############################################################################

SET(libkwavegui_LIB_SRCS
    CurveWidget.cpp
    FileDialog.cpp
    FilterPlugin.cpp
    FrequencyResponseWidget.cpp
    HMSTimeWidget.cpp
    ImageView.cpp
    InvertableSpinBox.cpp
    LabelItem.cpp
    LabelPropertiesWidget.cpp
    MenuNode.cpp
    MenuGroup.cpp
    MenuItem.cpp
    MenuSub.cpp
    MenuRoot.cpp
    MenuManager.cpp
    MouseMark.cpp
    MultiStateWidget.cpp
    OverViewCache.cpp
    OverViewWidget.cpp
    ScaleWidget.cpp
    SelectTimeWidget.cpp
    SignalView.cpp
    SignalWidget.cpp
    TrackPixmap.cpp
    TrackView.cpp
    TreeWidgetWrapper.cpp
    ViewItem.cpp
)

#############################################################################

SET(libkwavegui_LIB_UI
    HMSTimeWidgetBase.ui
    LabelPropertiesWidgetBase.ui
    SelectTimeWidgetBase.ui
)

#############################################################################

KDE4_ADD_UI_FILES(libkwavegui_LIB_SRCS ${libkwavegui_LIB_UI} )
QT4_AUTOMOC(${libkwavegui_LIB_SRCS})
KDE4_ADD_LIBRARY(libkwavegui SHARED ${libkwavegui_LIB_SRCS})

ADD_DEPENDENCIES(libkwavegui libkwave)

TARGET_LINK_LIBRARIES(libkwavegui
    kwave
    ${KDE4_KFILE_LIBS}
    ${QT_AND_KDECORE_LIBS}
)

SET_TARGET_PROPERTIES(libkwavegui PROPERTIES OUTPUT_NAME "kwavegui")
SET_TARGET_PROPERTIES(libkwavegui PROPERTIES LINK_FLAGS
    "-Wl,--export-dynamic")
SET_TARGET_PROPERTIES(libkwavegui PROPERTIES
    VERSION ${KWAVE_SOVERSION} SOVERSION ${KWAVE_VERSION_MAJOR} )
SET(LIBRARY_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR})

#############################################################################
### install files                                                         ###

INSTALL(TARGETS libkwavegui LIBRARY DESTINATION ${KDE4_LIB_INSTALL_DIR} NAMELINK_SKIP)

#############################################################################
#############################################################################

=== plugins/codec_flac/CMakeLists.txt ===
#############################################################################
##    Kwave                - plugins/codec_flac/CMakeLists.txt
##                           -------------------
##    begin                : Mon May 28 2007
##    copyright            : (C) 2007 by Thomas Eschenbacher
##    email                : Thomas.Eschenbacher@gmx.de
#############################################################################
#
#############################################################################
##                                                                          #
##    This program is free software; you can redistribute it and/or modify  #
##    it under the terms of the GNU General Public License as published by  #
##    the Free Software Foundation; either version 2 of the License, or     #
##    (at your option) any later version.                                   #
##                                                                          #
#############################################################################

OPTION(WITH_FLAC "enable support for FLAC files [default=on]" ON)
IF (WITH_FLAC)

    INCLUDE(CheckLibraryExists)

#############################################################################
### check for FLAC header files                                           ###

    CHECK_INCLUDE_FILES(FLAC/format.h HAVE_FLAC_HEADERS)
    IF (HAVE_FLAC_HEADERS)
        MESSAGE(STATUS "Found FLAC include files")
    ELSE (HAVE_FLAC_HEADERS)
        MESSAGE(FATAL_ERROR "libFLAC not found, please install libflac !")
    ENDIF (HAVE_FLAC_HEADERS)

#############################################################################
### check for FLAC++ header files                                         ###

    IF (HAVE_FLAC_HEADERS)
        CHECK_INCLUDE_FILES(FLAC++/decoder.h HAVE_FLAC_HEADERS)
    ENDIF (HAVE_FLAC_HEADERS)
    IF (HAVE_FLAC_HEADERS)
        CHECK_INCLUDE_FILES(FLAC++/metadata.h HAVE_FLAC_HEADERS)
    ENDIF (HAVE_FLAC_HEADERS)

    IF (HAVE_FLAC_HEADERS)
        MESSAGE(STATUS "Found FLAC++ include files")
    ELSE (HAVE_FLAC_HEADERS)
        MESSAGE(FATAL_ERROR "libFLAC++ not found, please install libflac++ !")
    ENDIF (HAVE_FLAC_HEADERS)

    SET(_try_src_dir "${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/CMakeTmp")

#############################################################################
### check for FLAC API v1.1.3 and above                                   ###
### known to work:
### - v1.1.3
### - v1.1.4
### - v1.2.0
### - v1.2.1
### (older ones are no longer supported)

    IF (NOT FLAC_API_FOUND)
        SET(_try_flac_1_1_3 "${_try_src_dir}/cmake_try_flac_v1_1_3.cpp")
        WRITE_FILE("${_try_flac_1_1_3}" "
            #include <FLAC/export.h>
            #include <FLAC/format.h>
            #include <FLAC++/decoder.h>
            #include <FLAC++/encoder.h>
            #include <FLAC++/metadata.h>

            /* FLAC-1.1.3 has cur=8, rev=0 */
            /* FLAC-1.1.4 has cur=8, rev=1 */
            #if !defined(FLAC_API_VERSION_CURRENT) || \\
                !defined(FLAC_API_VERSION_REVISION)
                #error "FLAC\ API\ is\ much\ too\ old"
            #endif

            #if (FLAC_API_VERSION_CURRENT < 8)
                #error "FLAC\ API\ is\ too\ old"
            #endif

            int main(int, char **)
            {
                FLAC__StreamEncoderInitStatus init_state_d =
                        FLAC__STREAM_ENCODER_INIT_STATUS_OK;
                FLAC__StreamDecoderInitStatus init_state_e =
                        FLAC__STREAM_DECODER_INIT_STATUS_OK;
                (void)init_state_d;
                (void)init_state_e;
                return 0;
            }
        ")

        TRY_COMPILE(
            FLAC_API_VERSION_1_1_3
            ${CMAKE_BINARY_DIR}
            ${_try_flac_1_1_3}
            CMAKE_FLAGS -DLINK_LIBRARIES:STRING=FLAC++
            OUTPUT_VARIABLE _out
        )
#         MESSAGE(STATUS ${_out})

        IF (FLAC_API_VERSION_1_1_3)
            MESSAGE(STATUS "Found FLAC API version 1.1.3 or newer")
            SET(FLAC_API_FOUND BOOL ON)
        ELSE (FLAC_API_VERSION_1_1_3)
            # failed, now try again with linking ogg
            WRITE_FILE("${_try_flac_1_1_3}" "
                #include <FLAC/export.h>
                #include <FLAC/format.h>
                #include <FLAC++/decoder.h>
                #include <FLAC++/encoder.h>
                #include <FLAC++/metadata.h>

                /* FLAC-1.1.3 has cur=8, rev=0 */
                /* FLAC-1.1.4 has cur=8, rev=1 */
                #if !defined(FLAC_API_VERSION_CURRENT) || \\
                    !defined(FLAC_API_VERSION_REVISION)
                    #error "FLAC\ API\ is\ much\ too\ old"
                #endif

                #if (FLAC_API_VERSION_CURRENT < 8)
                    #error "FLAC\ API\ is\ too\ old"
                #endif

                int main(int, char **)
                {
                    FLAC__StreamEncoderInitStatus init_state_d =
                            FLAC__STREAM_ENCODER_INIT_STATUS_OK;
                    FLAC__StreamDecoderInitStatus init_state_e =
                            FLAC__STREAM_DECODER_INIT_STATUS_OK;
                    (void)init_state_d;
                    (void)init_state_e;
                    return 0;
                }
            ")
            TRY_COMPILE(
                FLAC_API_VERSION_1_1_3
                ${CMAKE_BINARY_DIR}
                ${_try_flac_1_1_3}
                CMAKE_FLAGS -DLINK_LIBRARIES:STRING=FLAC++ -DLINK_LIBRARIES:STRING=ogg
                OUTPUT_VARIABLE _out
            )
            IF (FLAC_API_VERSION_1_1_3)
                SET(FLAC_NEEDS_OGG ogg)
                MESSAGE(STATUS "Found FLAC API version 1.1.3 or newer (needs libogg)")
                SET(FLAC_API_FOUND BOOL ON)
            ENDIF (FLAC_API_VERSION_1_1_3)
        ENDIF (FLAC_API_VERSION_1_1_3)

        IF (NOT FLAC_API_VERSION_1_1_3)
#             MESSAGE(STATUS "FLAC API v1.1.3 does not work")
#             MESSAGE(STATUS "${_out}")
        ENDIF (NOT FLAC_API_VERSION_1_1_3)
    ENDIF (NOT FLAC_API_FOUND)

#############################################################################
### abort if no working FLAC API has been found :-(                       ###

    IF (NOT FLAC_API_FOUND)
        MESSAGE(FATAL_ERROR "Found no supported FLAC API")
    ENDIF (NOT FLAC_API_FOUND)

    SET(HAVE_FLAC  ON CACHE BOOL "enable FLAC codec")
    SET(plugin_codec_flac_LIB_SRCS
        FlacCodecPlugin.cpp
        FlacDecoder.cpp
        FlacEncoder.cpp
    )

    SET(plugin_codec_flac_LIBS FLAC++ FLAC ${FLAC_NEEDS_OGG} )

    KWAVE_PLUGIN(codec_flac)

ENDIF(WITH_FLAC)

#############################################################################
#############################################################################

=== plugins/codec_ogg/CMakeLists.txt ===
#############################################################################
##    Kwave                - plugins/codec_ogg/CMakeLists.txt
##                           -------------------
##    begin                : Sat Jun 02 2007
##    copyright            : (C) 2007 by Thomas Eschenbacher
##    email                : Thomas.Eschenbacher@gmx.de
#############################################################################
#
#############################################################################
##                                                                          #
##    This program is free software; you can redistribute it and/or modify  #
##    it under the terms of the GNU General Public License as published by  #
##    the Free Software Foundation; either version 2 of the License, or     #
##    (at your option) any later version.                                   #
##                                                                          #
#############################################################################

OPTION(WITH_OGG_VORBIS "enable support for Ogg/Vorbis files [default=on]" ON)
OPTION(WITH_OGG_OPUS   "enable support for Ogg/Opus files [default=on]" ON)

SET(WITH_OGG OFF)
IF (WITH_OGG_OPUS OR WITH_OGG_VORBIS)
    SET(WITH_OGG ON)
ENDIF (WITH_OGG_OPUS OR WITH_OGG_VORBIS)

IF (WITH_OGG)

#############################################################################
### check for Ogg/Opus headers and library                                ###

    IF (WITH_OGG_OPUS)
	PKG_CHECK_MODULES(OPUS REQUIRED opus>=1.0.0)
	IF (NOT OPUS_FOUND)
	    MESSAGE(FATAL_ERROR "Opus codec not found")
	ENDIF(NOT OPUS_FOUND)

	MESSAGE(STATUS "Found Opus codec version ${OPUS_VERSION}")
# 	MESSAGE(STATUS "Found Opus codec library in ${OPUS_LIBDIR}")
# 	MESSAGE(STATUS "Found Opus codec headers in ${OPUS_INCLUDEDIR}")

	CHECK_LIBRARY_EXISTS(ogg ogg_stream_flush_fill "" HAVE_OGG_STREAM_FLUSH_FILL)

	SET(HAVE_OGG_OPUS  ON CACHE BOOL "enable Opus codec")
	SET(OGG_OPUS_LIBS "opus")
	SET(OGG_OPUS_SRCS
	    OpusCommon.cpp
	    OpusDecoder.cpp
	    OpusEncoder.cpp
	)
    ENDIF (WITH_OGG_OPUS)

#############################################################################
### check for Ogg/Vorbis headers and library                              ###

    IF (WITH_OGG_VORBIS)
	SET(OggVorbis_FIND_QUIETLY TRUE)
	INCLUDE(FindOggVorbis)

	CHECK_INCLUDE_FILES("vorbis/codec.h;vorbis/vorbisenc.h" HAVE_OGG_VORBIS_HEADERS)
	IF (HAVE_OGG_VORBIS_HEADERS)
	    SET(CMAKE_REQUIRED_LIBRARIES "vorbisenc;vorbis;ogg")
	    IF (OGGVORBIS_VERSION GREATER 1)
		SET(HAVE_OGG_VORBIS TRUE)
	    ENDIF (OGGVORBIS_VERSION GREATER 1)
	ENDIF (HAVE_OGG_VORBIS_HEADERS)

	IF (HAVE_OGG_VORBIS)
	    MESSAGE(STATUS "Found Ogg/Vorbis library v2.x or newer")
	ELSE (HAVE_OGG_VORBIS)
	    MESSAGE(FATAL_ERROR "

	    your system lacks support for at least libvorbis-devel!
	    please visit "http://vorbis.com" for obtainig a current version
	    of libogg and libvorbis plus the -devel packages if your
	    distribution does not include them.
	    ")
	ENDIF (HAVE_OGG_VORBIS)

	SET(HAVE_OGG_VORBIS ON CACHE BOOL "enable Vorbis codec")
	SET(OGG_VORBIS_LIBS vorbisenc vorbis)
	SET(OGG_VORBIS_SRCS
	    VorbisDecoder.cpp
	    VorbisEncoder.cpp
	)
    ENDIF (WITH_OGG_VORBIS)

    #############################################################################
    ### common part                                                           ###

    SET(plugin_codec_ogg_LIB_SRCS
        OggCodecPlugin.cpp
        OggDecoder.cpp
        OggEncoder.cpp
        ${OGG_OPUS_SRCS}
        ${OGG_VORBIS_SRCS}
    )

    SET(plugin_codec_ogg_LIBS
        ${OGG_OPUS_LIBS}
        ${OGG_VORBIS_LIBS}
        ogg
    )

    KWAVE_PLUGIN(codec_ogg)

ENDIF (WITH_OGG)

#############################################################################
#############################################################################

## kwave 0.8.10-1

=== debian/changelog ===
kwave (0.8.10-1-2) unstable; urgency=low

  * Upload to unstable
  * Update debian/control - fix vcs-field-not-canonical

 -- Mark Purcell <msp@debian.org>  Sun, 12 May 2013 09:56:58 +1000

kwave (0.8.10-1-1) experimental; urgency=low

  * New upstream release 
  * Added Build-Depends: libopus-dev (>= 1.0.0)

 -- Mark Purcell <msp@debian.org>  Sat, 02 Mar 2013 11:23:57 +1100

kwave (0.8.9-1-1) experimental; urgency=low

  * New upstream release

 -- Mark Purcell <msp@debian.org>  Mon, 19 Nov 2012 13:28:05 +1100

=== debian/control ===
Source: kwave
Section: kde
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Mark Purcell <msp@debian.org>
Build-Depends: debhelper (>= 9), pkg-kde-tools (>= 0.4),
 kdelibs5-dev (>= 4:4.2.0), gettext, pkg-config,
 libsamplerate0-dev, libpulse-dev,
 imagemagick, librsvg2-bin, recode, libid3-3.8.3-dev (>= 3.8.3-4.2),
 libaudiofile-dev (>> 0.3.0), libogg-dev, libvorbis-dev (>= 1.0.0-2), libopus-dev (>= 1.0.0),
 libflac++-dev (>= 1.1.4), libmad0-dev, libgsl0-dev,
 libasound2-dev [linux-any],
 libicu-dev,
 libfftw3-dev,
 poxml, gawk, cmake
Homepage: http://kwave.sourceforge.net
Standards-Version: 3.9.4
Vcs-Svn: svn://anonscm.debian.org/pkg-kde/kde-extras/kwave/trunk
Vcs-Browser: http://anonscm.debian.org/viewvc/pkg-kde/kde-extras/kwave/trunk?op=log

Package: kwave
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: sound editor for KDE
 Kwave is a sound editor designed for the KDE Desktop Environment.
 .
 With Kwave you can record, play back, import and edit many sorts of audio
 files including multi-channel files.
 .
 Kwave includes some plugins to transform audio files in several ways and
 presents a graphical view with a complete zoom- and scroll capability.
 .
 Its features include:
  * 24 Bit Support
  * Undo/Redo
  * Use of multicore CPUs (SMP, hyperthreading)
  * Simple Drag & Drop
  * Realtime Pre-Listen for some effects
  * Support for multi-track files
  * Playback and recording via native ALSA (or OSS, deprecated)
  * Playback via PulseAudio and Phonon
  * Load and edit-capability for large files (can use virtual memory)
  * Reading and auto-repair of damaged wav-files
  * Supports multiple windows
  * Extendable Plugin interface
  * a nice splashscreen
  * some label handling

Package: kwave-dbg
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, kwave (= ${binary:Version}) 
Priority: extra
Section: debug
Description: sound editor for KDE - debug symbols
 Kwave is a sound editor designed for the KDE Desktop Environment.
 .
 With Kwave you can record, play back, import and edit many sorts of audio
 files including multi-channel files.
 .
 This package includes the debug symbols.
